<template>
  <BasicLayout>
    <template #wrapper>
      <el-card class="box-card">
        <el-form ref="queryForm" :model="queryParams" :inline="true" label-width="68px">
          <el-form-item label="策略名称" prop="name"><el-input
            v-model="queryParams.name"
            placeholder="请输入策略名称"
            clearable
            size="small"
            @keyup.enter.native="handleQuery"
          />
          </el-form-item>
          <el-form-item label="状态" prop="status">
            <el-select v-model="queryParams.status" size="mini" placeholder="请选择订单类型" clearable>
              <el-option
                v-for="(item2, index2) in statusOptions"
                :key="'queryStatus.' + index2"
                :label="item2.label"
                :value="item2.value"
              />
            </el-select>
          </el-form-item>

          <el-form-item>
            <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
            <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
          </el-form-item>
        </el-form>

        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button
              v-permisaction="['admin:lineReduceStrategy:add']"
              type="primary"
              icon="el-icon-plus"
              size="mini"
              @click="handleAdd"
            >新增
            </el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button
              v-permisaction="['admin:lineReduceStrategy:edit']"
              type="success"
              icon="el-icon-edit"
              size="mini"
              :disabled="single"
              @click="handleUpdate"
            >修改
            </el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button
              v-permisaction="['admin:lineReduceStrategy:remove']"
              type="danger"
              icon="el-icon-delete"
              size="mini"
              :disabled="multiple"
              @click="handleDelete"
            >删除
            </el-button>
          </el-col>
        </el-row>

        <el-table v-loading="loading" :data="lineReduceStrategyList" @selection-change="handleSelectionChange">
          <el-table-column type="selection" width="55" align="center" />
          <el-table-column label="策略名称" align="center" prop="name" :show-overflow-tooltip="true" />
          <el-table-column label="状态" align="center" prop="status" :show-overflow-tooltip="true">
            <template slot-scope="scope">
              {{ statusFormat(scope.row.status) }}
            </template>
          </el-table-column>
          <el-table-column
            label="创建时间"
            align="center"
            prop="createdAt"
            width="150"
            :show-overflow-tooltip="true"
          >
            <template #default="{ row }">{{ parseTime(row.createdAt) }}</template>
          </el-table-column>
          <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
            <template slot-scope="scope">
              <el-popconfirm
                class="delete-popconfirm"
                title="确认要修改吗?"
                confirm-button-text="修改"
                @confirm="handleUpdate(scope.row)"
              >
                <el-button
                  slot="reference"
                  v-permisaction="['admin:lineReduceStrategy:edit']"
                  size="mini"
                  type="text"
                  icon="el-icon-edit"
                >修改
                </el-button>
              </el-popconfirm>
              <el-popconfirm
                class="delete-popconfirm"
                title="确认要删除吗?"
                confirm-button-text="删除"
                @confirm="handleDelete(scope.row)"
              >
                <el-button
                  slot="reference"
                  v-permisaction="['admin:lineReduceStrategy:remove']"
                  size="mini"
                  type="text"
                  icon="el-icon-delete"
                >删除
                </el-button>
              </el-popconfirm>
            </template>
          </el-table-column>
        </el-table>

        <pagination
          v-show="total > 0"
          :total="total"
          :page.sync="queryParams.pageIndex"
          :limit.sync="queryParams.pageSize"
          @pagination="getList"
        />

        <!-- 添加或修改对话框 -->
        <el-dialog :title="title" :visible.sync="open" width="800px">
          <el-form ref="form" :model="form" :rules="rules" label-width="80px">
            <el-form-item label="策略名称" prop="name">
              <el-input v-model="form.name" placeholder="减仓策略名称" show-word-limit maxlength="50" />
            </el-form-item>
            <el-form-item label="状态" prop="status">
              <el-radio-group v-model="form.status">
                <el-radio v-for="dict in statusOptions" :key="dict.value" :label="dict.value">{{
                  dict.label
                }}</el-radio>
              </el-radio-group>
            </el-form-item>
            <el-row>
              <el-col :span="4"><el-form-item label="减仓配置" /></el-col>
              <el-col :span="2"><el-button
                type="primary"
                size="mini"
                @click="onAddItem"
              >新增减仓</el-button></el-col>
            </el-row>
            <el-row
              v-for="(item, index) in form.items"
              :key="'item_' + index"
              style="margin-top: 10px;"
              :gutter="20"
            >
              <!-- <el-card shadow="hover"> -->
              <el-col :span="6">
                <el-form-item
                  label="亏损比例"
                  :prop="'items.' + index + '.lossPercent'"
                  :rules="rules.lossPercent"
                >
                  <el-input v-model="item.lossPercent" size="mini" placeholder="请输入亏损比例" />
                </el-form-item>
              </el-col>
              <el-col :span="6">
                <el-form-item label="减仓比例" :prop="'items.' + index + '.quantityPercent'" :rules="rules.quantityPercent">
                  <el-input v-model="item.quantityPercent" size="mini" placeholder="请输入减仓数量比例" />
                </el-form-item>
              </el-col>
              <el-col :span="6">
                <el-form-item
                  label="订单类型"
                  :prop="'items.' + index + '.orderType'"
                  :rules="rules.orderType"
                >
                  <el-select v-model="item.orderType" size="mini" placeholder="请选择订单类型">
                    <el-option
                      v-for="(item2, index2) in orderTypeOptions"
                      :key="index + '.orderType.' + index2"
                      :label="item2.label"
                      :value="item2.value"
                    />
                  </el-select>
                </el-form-item>
              </el-col>
              <!-- <el-form-item> -->
              <!-- </el-form-item> -->
              <el-col :span="4" style="height: 36px; line-height: 36px;"><el-button
                size="mini"
                type="danger"
                @click="removeItem(index)"
              >删除</el-button></el-col>
              <!-- </el-card> -->
            </el-row>

          </el-form>
          <div slot="footer" class="dialog-footer">
            <el-button type="primary" @click="submitForm">确 定</el-button>
            <el-button @click="cancel">取 消</el-button>
          </div>
        </el-dialog>
      </el-card>
    </template>
  </BasicLayout>
</template>

<script>
import { addLineReduceStrategy, delLineReduceStrategy, getLineReduceStrategy, listLineReduceStrategy, updateLineReduceStrategy } from '@/api/admin/line-reduce-strategy'

export default {
  name: 'LineReduceStrategy',
  components: {
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 总条数
      total: 0,
      // 弹出层标题
      title: '',
      // 是否显示弹出层
      open: false,
      isEdit: false,
      // 类型数据字典
      typeOptions: [],
      lineReduceStrategyList: [],
      orderTypeOptions: [{
        value: 'LIMIT',
        label: '限价'
      }, {
        value: 'MARKET',
        label: '市价'
      }],
      statusOptions: [{
        value: 1,
        label: '启用'
      }, {
        value: 2,
        label: '禁用'
      }],
      // 关系表类型

      // 查询参数
      queryParams: {
        pageIndex: 1,
        pageSize: 10,
        name: undefined,
        status: undefined,
        idOrder: 'desc'
      },
      // 表单参数
      form: {
      },
      // 表单校验
      rules: {
        name: [{ required: true, message: '减仓策略名称不能为空', trigger: 'blur' }],
        status: [{ required: true, message: '状态 1-启用 2-禁用不能为空', trigger: 'blur' }],
        lossPercent: [{ required: true, message: '亏损百分比不能为空', trigger: 'blur' },
          { validator: this.validateOrderType, trigger: 'blur' }],
        orderType: [{ required: true, message: '订单类型不能为空', trigger: 'blur' }
        ],
        quantityPercent: [{ required: true, message: '减仓数量百分比不能为空', trigger: 'blur' },
          { validator: this.validateQuantityPercent, trigger: 'blur' }
        ]
      }
    }
  },
  created() {
    this.getList()
  },
  methods: {
    // 校验节点百分比
    validateOrderType(rule, value, callback) {
      const index = rule.fullField.split('.')[1] // 获取索引
      const item = this.form.items[index]

      if (value === '') {
        callback(new Error('不能为空'))
      } else if (isNaN(value)) {
        callback(new Error('必须输入数字'))
      } else if (value < 0) {
        callback(new Error('百分比不能小于 0'))
      }

      if (index > 0 && item.lossPercent <= this.form.items[index - 1].lossPercent) {
        callback(new Error('亏损百分比不能小于上一节点'))
      } else {
        callback()
      }
    },
    validateQuantityPercent(rule, value, callback) {
      // const index = rule.fullField.split('.')[1] // 获取索引

      if (value === '') {
        callback(new Error('不能为空'))
      } else if (isNaN(value)) {
        callback(new Error('必须输入数字'))
      } else if (value < 0) {
        callback(new Error('百分比不能小于 0'))
      } else if (value > 100) {
        callback(new Error('百分比不能大于 100'))
      } else {
        callback()
      }
    },
    /** 查询参数列表 */
    getList() {
      this.loading = true
      listLineReduceStrategy(this.addDateRange(this.queryParams, this.dateRange)).then(response => {
        this.lineReduceStrategyList = response.data.list
        this.total = response.data.count
        this.loading = false
      }
      )
    },
    statusFormat(status) {
      const op = this.statusOptions.find(x => x.value === status)

      if (op) {
        return op.label
      }

      return ''
    },
    // 取消按钮
    cancel() {
      this.open = false
      this.reset()
    },
    // 表单重置
    reset() {
      this.form = {

        id: undefined,
        name: undefined,
        status: 1,
        items: []
      }
      this.resetForm('form')
    },
    getImgList: function() {
      this.form[this.fileIndex] = this.$refs['fileChoose'].resultList[0].fullUrl
    },
    fileClose: function() {
      this.fileOpen = false
    },
    // 关系
    // 文件
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageIndex = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRange = []
      this.resetForm('queryForm')
      this.handleQuery()
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset()
      this.open = true
      this.title = '添加减仓策略'
      this.isEdit = false
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset()
      const id =
                row.id || this.ids
      getLineReduceStrategy(id).then(response => {
        this.form = response.data
        this.open = true
        this.title = '修改减仓策略'
        this.isEdit = true
      })
    },
    /** 提交按钮 */
    submitForm: function() {
      this.$refs['form'].validate(valid => {
        if (valid) {
          if (this.form.id !== undefined) {
            updateLineReduceStrategy(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess(response.msg)
                this.open = false
                this.getList()
              } else {
                this.msgError(response.msg)
              }
            })
          } else {
            addLineReduceStrategy(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess(response.msg)
                this.open = false
                this.getList()
              } else {
                this.msgError(response.msg)
              }
            })
          }
        }
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      var Ids = (row.id && [row.id]) || this.ids

      this.$confirm('是否确认删除编号为"' + Ids + '"的数据项?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(function() {
        return delLineReduceStrategy({ 'ids': Ids })
      }).then((response) => {
        if (response.code === 200) {
          this.msgSuccess(response.msg)
          this.open = false
          this.getList()
        } else {
          this.msgError(response.msg)
        }
      }).catch(function() {
      })
    },
    onAddItem() {
      this.form.items.push({ lossPercent: undefined, orderType: 'LIMIT' })
    },
    removeItem(index) {
      this.form.items.splice(index, 1)
    }
  }
}
</script>
